Program Triatlon;
Uses Crt;
Const BemenetiFile = 'triatlon.be';
      KimenetiFile = 'triatlon.ki';
      ReszKiFile = 'reszer.ki';
Type TVersenyzo = Record
         nev : String;
         Uszas, kerekpar, futas : Word;
         Ido : Integer;
     End;
     TTomb = Array[1..10] of TVersenyzo;
Var Versenyzok : TTomb;
    N, cv : Byte;
    VUszas, VKerekp, VFutas : Real;

Procedure Beolvas(Var N : Byte; Var T : TTomb);
Var TF : Text;
    cv : Word;
    sv : TVersenyzo;

Begin
  Assign(TF,bemenetifile);
  Reset(TF);
  cv := 1;
  While NOT EOF(TF) Do
   Begin
     Readln(TF,sv.nev);
     Readln(TF,sv.uszas);
     Readln(TF,sv.kerekpar);
     Readln(TF,sv.futas);
     T[cv] := sv;
     inc(cv);
   End;
  N := cv-1;
  Close(TF);
End;

Procedure OsszIdo(N : Byte; Var V : TTomb);
Var szum : Word;
    cv : Byte;
Begin
  for cv := 1 to N Do
   Begin
     szum := 0;
     inc(szum,V[cv].uszas);
     inc(szum,V[cv].kerekpar);
     inc(szum,V[cv].futas);
     V[cv].Ido := szum;
   End;

End;

procedure csere(Var a, b : TVersenyzo);
Var sv : TVersenyzo;
Begin
  sv := a;
   a := b;
   b := sv;
End;

procedure Rendez(N : Byte; Var V : TTomb);
Var i, j : Byte;
Begin
 For i := 1 to N-1 Do
   For j := i+1 to N DO
     if V[i].Ido > V[j].Ido then csere(V[i],V[j]);

End;

Procedure Atlagsebessegek(Var u,k,f : Real;V : TVersenyzo);
Begin

  u := 1.5*3600/V.uszas;
  k := 40*3600/V.kerekpar;
  f := 10*3600/V.futas;

End;


Function SecToIdo(Sec : Integer ) : String;
Var o, p : Byte;
    sv,so, sp, ss  : String;
Begin
  Sv := '';
  o := sec div 3600;
  Str(o,so);
  If o < 10 then
    Sv := sv + '0' + so + ':'
  Else
    Sv := sv + so + ':';
  Sec := Sec mod 3600;
  p := sec div 60;
  Str(p,sp);
  if p < 10 then
    Sv := sv + '0' + sp + ':'
  Else
    Sv := sv + sp + ':';
  Sec := Sec mod 60;

  Str(sec,ss);
  if sec < 10 then
    Sv := sv + '0' + ss
  Else
    Sv := sv + ss;
  SecToIdo := sv;
End;


Procedure FilebaKiirIdo( N : Byte; T : TTomb);
Var TF : Text;
    cv : Byte;
Begin
  Assign(TF,KimenetiFile);
  ReWrite(TF);
  For cv := 1 to N Do
    Begin
      Write(TF,T[cv].nev);
      Write(TF,'   ');
      Writeln(TF,SecToIdo(T[cv].Ido));
    End;
  Close(TF);
End;


Procedure MAXKivalasztas(N : Byte; T : TTomb; Miben : Byte; Var Max : Byte);
Var cv : Byte;
Begin
 MAx := 1;
 For cv := 2 to N DO
    Case Miben of
      1 : if T[Max].Uszas < T[cv].Uszas then Max := cv;
      2 : if T[Max].Kerekpar < T[cv].Kerekpar then Max := cv;
      3 : if T[Max].Futas < T[cv].Futas then Max := cv;
    End;
End;

Procedure Reszeredmeny(N : Byte; T : TTomb);
Var Max : Byte;
    TF : Text;
Begin
  Assign(TF,ReszKiFile);
  ReWrite(TF);
    MaxKivalasztas(N, T, 1, Max);
    Writeln(TF, T[Max].nev);

    MaxKivalasztas(N, T, 2, Max);
    Writeln(TF, T[Max].nev);

    MaxKivalasztas(N, T, 3, Max);
    Writeln(TF, T[Max].nev);

  Close(TF);

End;

BEGIN
 clrscr;
 Beolvas(N, Versenyzok);
 OsszIdo(N, Versenyzok);
 Rendez(N, Versenyzok);
 For cv := 1 to 3 Do
   Writeln(cv,'. helyezett: ',Versenyzok[cv].nev);
 Atlagsebessegek(VUszas,Vkerekp,VFutas,Versenyzok[1]);
 Writeln('az 1. helyezett ', Versenyzok[1].nev, ' tlagsebessgei.');
 Writeln('Uszs: ', VUszas:3:2,' km\h');
 Writeln('Kerkpr: ', VKerekp:3:2,' km\h');
 Writeln('Futs: ', VFutas:3:2,' km\h');
 FilebaKiirIdo(N,Versenyzok);
 Writeln('A triatlon.ki fileba az idoeredmenyek kiirasa befejezodott.');
 Reszeredmeny(N,Versenyzok);
 Writeln('A reszer.ki fileba a reszeredmenyek kiirasa befejezodott.');
 Readln;

END.